/*
 * $Id: parse.h,v 1.13 2003/04/12 02:40:40 jasta Exp $
 *
 * Copyright (C) 2001-2003 giFT project (gift.sourceforge.net)
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2, or (at your option) any
 * later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 */

#ifndef __PARSE_H
#define __PARSE_H

/*****************************************************************************/

#include "strobj.h"

/*****************************************************************************/

#ifdef __cplusplus
extern "C"
{
#endif /* __reallycrappylanguage */

/*****************************************************************************/

char         *stringf          (const char *fmt, ...);
char         *stringf_dup      (const char *fmt, ...);

char         *string_upper     (char *s);
char         *string_lower     (char *s);

#ifndef TCG_LEAK_DETECT
char         *STRDUP           (char *s);
#else
#define       STRDUP           strdup
#endif

#define       STRLEN(str)      (str ? strlen (str) : 0)
#define       STRLEN_0(str)    (str ? (strlen (str) + 1) : 0)

#define       STRING_NULL(str)    ((str && *str) ? str : NULL)
#define       STRING_NOTNULL(str) ((str) ? str : "")

/* this is a poorly named function :/ */
char         *STRDUP_N         (char *string, size_t string_len);

int           STRCMP           (char *s1, char *s2);
long          ATOI             (char *string);
unsigned long ATOUL            (char *string);
char         *ITOA             (long integer);

void         *memory_dup       (void *src, size_t len);
void          string_move      (char *dst, const char *src);
int           string_isempty   (char *string);
char         *string_trim      (char *string);
char         *string_sep_set   (char **string, char *charset);
char         *string_sep       (char **string, char *delim);

/*****************************************************************************/

#ifdef __cplusplus
}
#endif /* __reallycrappylanguage */

/*****************************************************************************/

#endif /* __PARSE_H */
